libstdc++: __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc > Class Template Referenceabstract

`#include <trie_policy.hpp>`

Inheritance diagram for __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >:
[legend]

## Public Types
typedef access_traits::const_iterator | a_const_iterator
typedef _ATraits | access_traits
typedef _Alloc | allocator_type
typedef node_const_iterator::value_type | const_iterator
typedef node_iterator::value_type | iterator
typedef base_type::key_const_reference | key_const_reference
typedef base_type::key_type | key_type
typedef null_type | metadata_type
typedef Node_CItr | node_const_iterator
typedef Node_Itr | node_iterator
typedef allocator_type::size_type | size_type

## Public Member Functions
std::pair< iterator, iterator > | prefix_range (a_const_iterator, a_const_iterator)
std::pair< const_iterator, const_iterator > | prefix_range (a_const_iterator, a_const_iterator) const
std::pair< iterator, iterator > | prefix_range (key_const_reference)
std::pair< const_iterator, const_iterator > | prefix_range (key_const_reference) const

## Protected Member Functions
void | operator() (node_iterator node_it, node_const_iterator end_nd_it) const

## Detailed Description

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>
class __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >

A node updator that allows tries to be searched for the range of values that match a certain prefix.

Definition at line 155 of file trie_policy.hpp.

## Member Typedef Documentation

## ◆ a_const_iterator

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef access_traits::const_iterator __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::a_const_iterator

Const element iterator.

Definition at line 168 of file trie_policy.hpp.

## ◆ access_traits

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef _ATraits __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::access_traits

Element access traits.

Definition at line 165 of file trie_policy.hpp.

## ◆ allocator_type

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef _Alloc __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::allocator_type

_Alloc type.

Definition at line 171 of file trie_policy.hpp.

## ◆ const_iterator

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef node_const_iterator::value_type __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::const_iterator

Definition at line 179 of file trie_policy.hpp.

## ◆ iterator

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef node_iterator::value_type __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::iterator

Definition at line 178 of file trie_policy.hpp.

## ◆ key_const_reference

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef base_type::key_const_reference __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::key_const_reference

Definition at line 162 of file trie_policy.hpp.

## ◆ key_type

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef base_type::key_type __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::key_type

Definition at line 161 of file trie_policy.hpp.

## ◆ metadata_type

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef null_type __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::metadata_type

Definition at line 175 of file trie_policy.hpp.

## ◆ node_const_iterator

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef Node_CItr __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::node_const_iterator

Definition at line 177 of file trie_policy.hpp.

## ◆ node_iterator

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef Node_Itr __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::node_iterator

Definition at line 176 of file trie_policy.hpp.

## ◆ size_type

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

typedef allocator_type::size_type __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::size_type

Size type.

Definition at line 174 of file trie_policy.hpp.

## Member Function Documentation

## ◆ operator()()

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

void __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::operator() | ( | node_iterator | node_it,
|  | node_const_iterator | end_nd_it ) const
| inlineprotected

Called to update a node's metadata.

Definition at line 140 of file trie_policy.hpp.

## ◆ prefix_range() [1/4]

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

std::pair< typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::iterator, typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::iterator > __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range | ( | a_const_iterator | b,
|  | a_const_iterator | e )

Finds the iterator range corresponding to all values whose prefixes match [b, e).

Definition at line 85 of file trie_policy.hpp.

## ◆ prefix_range() [2/4]

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

std::pair< typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::const_iterator, typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::const_iterator > __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range | ( | a_const_iterator | b,
|  | a_const_iterator | e ) const

Finds the const iterator range corresponding to all values whose prefixes match [b, e).

Definition at line 70 of file trie_policy.hpp.

## ◆ prefix_range() [3/4]

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

std::pair< typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::iterator, typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::iterator > __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range | ( | key_const_reference | r_key | ) |

Finds the iterator range corresponding to all values whose prefixes match r_key.

Definition at line 59 of file trie_policy.hpp.

## ◆ prefix_range() [4/4]

template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>

std::pair< typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::const_iterator, typename trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::const_iterator > __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range | ( | key_const_reference | r_key | ) | const

Finds the const iterator range corresponding to all values whose prefixes match r_key.

Definition at line 48 of file trie_policy.hpp.

The documentation for this class was generated from the following file:

- trie_policy.hpp